net.sourceforge.pmd.lang.ecmascript.ast

## Interface EcmascriptNode<T extends org.mozilla.javascript.ast.AstNode>

All Superinterfaces:
  Node

All Known Implementing Classes:
  AbstractEcmascriptNode, AbstractInfixEcmascriptNode, ASTArrayComprehension, ASTArrayComprehensionLoop, ASTArrayLiteral, ASTAssignment, ASTAstRoot, ASTBlock, ASTBreakStatement, ASTCatchClause, ASTComment, ASTConditionalExpression, ASTContinueStatement, ASTDoLoop, ASTElementGet, ASTEmptyExpression, ASTExpressionStatement, ASTForInLoop, ASTForLoop, ASTFunctionCall, ASTFunctionNode, ASTIfStatement, ASTInfixExpression, ASTKeywordLiteral, ASTLabel, ASTLabeledStatement, ASTLetNode, ASTName, ASTNewExpression, ASTNumberLiteral, ASTObjectLiteral, ASTObjectProperty, ASTParenthesizedExpression, ASTPropertyGet, ASTRegExpLiteral, ASTReturnStatement, ASTScope, ASTStringLiteral, ASTSwitchCase, ASTSwitchStatement, ASTThrowStatement, ASTTryStatement, ASTUnaryExpression, ASTVariableDeclaration, ASTVariableInitializer, ASTWhileLoop, ASTWithStatement, ASTXmlDotQuery, ASTXmlExpression, ASTXmlMemberGet, ASTXmlString

    public interface EcmascriptNode<T extends org.mozilla.javascript.ast.AstNode>
    extends Node

### Method Summary

Methods
`Object` `childrenAccept(EcmascriptParserVisitor visitor, Object data)` Accept the visitor
`String` `getJsDoc()` Get the JsDoc associated with the given node.
`T` `getNode()` Get the underlying Rhino AST node.
`boolean` `hasSideEffects()`
`Object` `jjtAccept(EcmascriptParserVisitor visitor, Object data)` Accept the visitor

### Methods inherited from interface net.sourceforge.pmd.lang.ast.Node

`findChildNodesWithXPath, findChildrenOfType, findDescendantsOfType, findDescendantsOfType, getAsDocument, getBeginColumn, getBeginLine, getDataFlowNode, getEndColumn, getEndLine, getFirstChildOfType, getFirstDescendantOfType, getFirstParentOfType, getImage, getNthParent, getParentsOfType, getUserData, hasDescendantMatchingXPath, hasDescendantOfType, hasImageEqualTo, isFindBoundary, jjtAddChild, jjtClose, jjtGetChild, jjtGetId, jjtGetNumChildren, jjtGetParent, jjtOpen, jjtSetParent, setDataFlowNode, setImage, setUserData`

### Method Detail

#### jjtAccept

    Object jjtAccept(EcmascriptParserVisitor visitor,
                   Object data)

Accept the visitor. *

#### childrenAccept

    Object childrenAccept(EcmascriptParserVisitor visitor,
                        Object data)

Accept the visitor. *

#### getNode

    T getNode()

Get the underlying Rhino AST node.

#### getJsDoc

    String getJsDoc()

Get the JsDoc associated with the given node. If there is no JsDoc on this node, it may be associated with a parent node, on more representative of the entire expression containing this node.

Returns:
  The JsDoc comment for the node, may be `null`.

#### hasSideEffects

    boolean hasSideEffects()